#include "mppdec.h"

Bool_t  stderr_silent = 0;

void
SetStderrSilent ( Bool_t state )
{
    stderr_silent = state;
}

int Cdecl
stderr_printf ( const char* format, ... )
{
    char     buff [2 * PATHLEN_MAX + 3072];
    char*    p = buff;
    char*    q;
    int      ret;
    va_list  v;

    /* print to a buffer */
    va_start ( v, format );
    ret = vsprintf ( p, format, v );
    va_end ( v );

    if ( !stderr_silent ) {
#if defined __unix__  ||  defined __UNIX__
        WRITE ( STDERR, buff, ret );
#else
        // for non-Unix systems we must merge carriage returns into the stream to avoid staircases
        while ( ( q = strchr (p, '\n')) != NULL ) {
            WRITE ( STDERR, p, q-p );
            WRITE ( STDERR, "\r\n", 2 );
            p = q+1;
        }
        WRITE ( STDERR, p, strlen (p) );
#endif
    }

    return ret;
}

/* end of stderr.c */
